
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8L
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : float, width, precision
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Timer0counter0=R5

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x30,0x0
	.DB  0x30,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1F,0xFE,0x3F,0xFF,0x30,0x3,0x30,0x3
	.DB  0x30,0x3,0x30,0x3,0x3F,0xFF,0x1F,0xFE
	.DB  0x0,0x0,0x30,0x0,0x30,0xC,0x3F,0xFF
	.DB  0x3F,0xFF,0x30,0x0,0x30,0x0,0x0,0x0
	.DB  0x1E,0xC3,0x3F,0xC3,0x30,0xC3,0x30,0xC3
	.DB  0x30,0xC3,0x30,0xC3,0x30,0xFF,0x30,0x7E
	.DB  0x30,0xC3,0x30,0xC3,0x30,0xC3,0x30,0xC3
	.DB  0x30,0xC3,0x30,0xC3,0x3F,0xFF,0x1F,0xBE
	.DB  0x0,0xFF,0x0,0xFF,0x0,0xC0,0x0,0xC0
	.DB  0x0,0xC0,0x0,0xC0,0x3F,0xFF,0x3F,0xFF
	.DB  0x30,0x7E,0x30,0xFF,0x30,0xC3,0x30,0xC3
	.DB  0x30,0xC3,0x30,0xC3,0x3F,0xC3,0x1F,0x83
	.DB  0x1F,0x7E,0x3F,0xFF,0x30,0xC3,0x30,0xC3
	.DB  0x30,0xC3,0x30,0xC3,0x3F,0xC3,0x1F,0x82
	.DB  0x0,0x3,0x0,0x3,0x0,0x3,0x0,0x3
	.DB  0x0,0x3,0x0,0x3,0x3F,0xFF,0x3F,0xFE
	.DB  0x1F,0xBE,0x3F,0xFF,0x30,0xC3,0x30,0xC3
	.DB  0x30,0xC3,0x30,0xC3,0x3F,0xFF,0x1F,0xBE
	.DB  0x10,0x7E,0x30,0xFF,0x30,0xC3,0x30,0xC3
	.DB  0x30,0xC3,0x30,0xC3,0x3F,0xFF,0x1F,0xBE
	.DB  0x0,0x0,0x0,0xC0,0x0,0xC0,0x3,0xF0
	.DB  0x3,0xF0,0x0,0xC0,0x0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0xC0,0x0,0xC0,0x0,0xC0
	.DB  0x0,0xC0,0x0,0xC0,0x0,0xC0
_0x61:
	.DB  0x0
_0x0:
	.DB  0x25,0x31,0x2E,0x32,0x66,0x25,0x63,0x20
	.DB  0x25,0x75,0x0
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x208005F:
	.DB  0x1
_0x2080000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0xDE
	.DW  _FontKCB
	.DW  _0x3*2

	.DW  0x01
	.DW  0x05
	.DW  _0x61*2

	.DW  0x01
	.DW  __seed_G104
	.DW  _0x208005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 17.11.2012
;Author  : NeVaDa
;Company : Zerro
;Comments:
;
;
;Chip type               : ATmega8L
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;
;
;#include "font_8x14.c"
;unsigned char FontKCB[] = {
;// 0
;0b00000000, 0b00000000, // space
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;
;// 1
;0b00000000, 0b00000000, // .
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;0b00110000, 0b00000000,
;0b00110000, 0b00000000,
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;0b00000000, 0b00000000,
;
;// 2
;0b00011111, 0b11111110, // 0
;0b00111111, 0b11111111,
;0b00110000, 0b00000011,
;0b00110000, 0b00000011,
;0b00110000, 0b00000011,
;0b00110000, 0b00000011,
;0b00111111, 0b11111111,
;0b00011111, 0b11111110,
;
;// 3
;0b00000000, 0b00000000, // 1
;0b00110000, 0b00000000,
;0b00110000, 0b00001100,
;0b00111111, 0b11111111,
;0b00111111, 0b11111111,
;0b00110000, 0b00000000,
;0b00110000, 0b00000000,
;0b00000000, 0b00000000,
;
;// 4
;0b00011110, 0b11000011, // 2
;0b00111111, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11111111,
;0b00110000, 0b01111110,
;
;// 5
;0b00110000, 0b11000011, // 3
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00111111, 0b11111111,
;0b00011111, 0b10111110,
;
;// 6
;0b00000000, 0b11111111, // 4
;0b00000000, 0b11111111,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00111111, 0b11111111,
;0b00111111, 0b11111111,
;
;// 7
;0b00110000, 0b01111110, // 5
;0b00110000, 0b11111111,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00111111, 0b11000011,
;0b00011111, 0b10000011,
;
;// 8
;0b00011111, 0b01111110, // 6
;0b00111111, 0b11111111,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00111111, 0b11000011,
;0b00011111, 0b10000010,
;
;// 9
;0b00000000, 0b00000011, // 7
;0b00000000, 0b00000011,
;0b00000000, 0b00000011,
;0b00000000, 0b00000011,
;0b00000000, 0b00000011,
;0b00000000, 0b00000011,
;0b00111111, 0b11111111,
;0b00111111, 0b11111110,
;
;// 10
;0b00011111, 0b10111110, // 8
;0b00111111, 0b11111111,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00111111, 0b11111111,
;0b00011111, 0b10111110,
;
;// 11
;0b00010000, 0b01111110, // 9
;0b00110000, 0b11111111,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00110000, 0b11000011,
;0b00111111, 0b11111111,
;0b00011111, 0b10111110,
;
;// 12
;0b00000000, 0b00000000, // +
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000011, 0b11110000,
;0b00000011, 0b11110000,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b00000000,
;
;// 13
;0b00000000, 0b00000000, // -
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b11000000,
;0b00000000, 0b00000000
;
;
;};

	.DSEG
;
;#define ADC_VREF_TYPE 0xC0
;
;
;__eeprom unsigned char EEprevzamerFLAG;    //  
;__eeprom unsigned char EEprevzamer0[8];    //  
;__eeprom unsigned char EEprevzamer1[8];    //  
;
;unsigned char stringBuff[9];
;unsigned char Timer0counter0=0;
;bit FlagShowZamer=0;
;
;
;
;// Read the AD conversion result
;unsigned int read_adc(unsigned char adc_input){
; 0000 002D unsigned int read_adc(unsigned char adc_input){

	.CSEG
_read_adc:
; 0000 002E ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,LOW(0xC0)
	OUT  0x7,R30
; 0000 002F // Delay needed for the stabilization of the ADC input voltage
; 0000 0030 delay_us(10);
	__DELAY_USB 27
; 0000 0031 // Start the AD conversion
; 0000 0032 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0033 // Wait for the AD conversion to complete
; 0000 0034 while ((ADCSRA & 0x10)==0);
_0x4:
	SBIS 0x6,4
	RJMP _0x4
; 0000 0035 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0036 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	RJMP _0x20A0007
; 0000 0037 }
;
;
;
;
;// ::: ST :::::::::::::::::    ::::::::::::::::::::::::::::::::::::::::
;
;void LcdSend(unsigned char data){
; 0000 003E void LcdSend(unsigned char data){
_LcdSend:
; 0000 003F //  Send data to display controller.
; 0000 0040 SPDR = data;
;	data -> Y+0
	LD   R30,Y
	OUT  0xF,R30
; 0000 0041 //  Wait until Tx register empty.
; 0000 0042 while ( (SPSR & 0x80) != 0x80 );
_0x7:
	IN   R30,0xE
	ANDI R30,LOW(0x80)
	CPI  R30,LOW(0x80)
	BRNE _0x7
; 0000 0043 return;
_0x20A0007:
	ADIW R28,1
	RET
; 0000 0044 }
;
;// ::: EN :::::::::::::::::    ::::::::::::::::::::::::::::::::::::::::
;
;
;
;// ::: ST :::::::::::::::::   ::::::::::::::::::::::::::::::::::::::::
;void ClearLcd(void){
; 0000 004B void ClearLcd(void){
_ClearLcd:
; 0000 004C unsigned char col, page;
; 0000 004D 
; 0000 004E for(page = 0; page < 8; page++){
	RCALL __SAVELOCR2
;	col -> R17
;	page -> R16
	LDI  R16,LOW(0)
_0xB:
	CPI  R16,8
	BRSH _0xC
; 0000 004F PORTB.0=0; //    
	CBI  0x18,0
; 0000 0050 LcdSend((page | 0x40));
	MOV  R30,R16
	RCALL SUBOPT_0x0
; 0000 0051 LcdSend(0x80);
; 0000 0052 PORTB.0=1; //    
; 0000 0053 for (col = 0; col < 96; col++){LcdSend(0x00);}
_0x12:
	CPI  R17,96
	BRSH _0x13
	RCALL SUBOPT_0x1
	SUBI R17,-1
	RJMP _0x12
_0x13:
; 0000 0054 
; 0000 0055 }
	SUBI R16,-1
	RJMP _0xB
_0xC:
; 0000 0056 
; 0000 0057 }
	RCALL __LOADLOCR2P
	RET
;// ::: EN :::::::::::::::::   ::::::::::::::::::::::::::::::::::::::::
;
;
;
;// ::: ST :::::::::::::::::     ::::::::::::::::::::::::::::::::::::::::
;void StringToLcd(unsigned char stringnum){
; 0000 005D void StringToLcd(unsigned char stringnum){
_StringToLcd:
; 0000 005E unsigned char n, m, symb;
; 0000 005F PORTB.0=0; //    
	RCALL __SAVELOCR4
;	stringnum -> Y+4
;	n -> R17
;	m -> R16
;	symb -> R19
	CBI  0x18,0
; 0000 0060 LcdSend((stringnum*2) | 0x40);
	LDD  R30,Y+4
	LSL  R30
	RCALL SUBOPT_0x0
; 0000 0061 LcdSend(0x80);
; 0000 0062 PORTB.0=1; //    
; 0000 0063 
; 0000 0064 for (n=0; n<8; n++){
_0x19:
	CPI  R17,8
	BRSH _0x1A
; 0000 0065 symb=stringBuff[n];
	RCALL SUBOPT_0x2
; 0000 0066 if (symb >47){symb=symb-46;}else{
	BRLO _0x1B
	RCALL SUBOPT_0x3
	SBIW R30,46
	MOV  R19,R30
	RJMP _0x1C
_0x1B:
; 0000 0067 if (symb == 43){symb=12;}else{
	CPI  R19,43
	BRNE _0x1D
	LDI  R19,LOW(12)
	RJMP _0x1E
_0x1D:
; 0000 0068 if (symb == 45){symb=13;}else{
	CPI  R19,45
	BRNE _0x1F
	LDI  R19,LOW(13)
	RJMP _0x20
_0x1F:
; 0000 0069 if (symb == 46){symb=1;}else{
	CPI  R19,46
	BRNE _0x21
	LDI  R19,LOW(1)
	RJMP _0x22
_0x21:
; 0000 006A symb=0;
	LDI  R19,LOW(0)
; 0000 006B }}}}
_0x22:
_0x20:
_0x1E:
_0x1C:
; 0000 006C if (symb >13){symb=0;}
	CPI  R19,14
	BRLO _0x23
	LDI  R19,LOW(0)
; 0000 006D symb=symb*16+1;
_0x23:
	LDI  R26,LOW(16)
	MULS R19,R26
	MOVW R30,R0
	SUBI R30,-LOW(1)
	MOV  R19,R30
; 0000 006E for (m=0; m<8; m++){LcdSend(FontKCB[symb]); symb=symb+2;}
	LDI  R16,LOW(0)
_0x25:
	CPI  R16,8
	BRSH _0x26
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	SUBI R16,-1
	RJMP _0x25
_0x26:
; 0000 006F LcdSend(0x00);
	RCALL SUBOPT_0x1
; 0000 0070 }
	SUBI R17,-1
	RJMP _0x19
_0x1A:
; 0000 0071 
; 0000 0072 PORTB.0=0; //    
	CBI  0x18,0
; 0000 0073 LcdSend((stringnum*2+1) | 0x40);
	LDD  R30,Y+4
	LSL  R30
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x0
; 0000 0074 LcdSend(0x80);
; 0000 0075 PORTB.0=1; //    
; 0000 0076 
; 0000 0077 for (n=0; n<8; n++){
_0x2C:
	CPI  R17,8
	BRSH _0x2D
; 0000 0078 symb=stringBuff[n];
	RCALL SUBOPT_0x2
; 0000 0079 if (symb >47){symb=symb-46;}else{
	BRLO _0x2E
	RCALL SUBOPT_0x3
	SBIW R30,46
	MOV  R19,R30
	RJMP _0x2F
_0x2E:
; 0000 007A if (symb == 43){symb=12;}else{
	CPI  R19,43
	BRNE _0x30
	LDI  R19,LOW(12)
	RJMP _0x31
_0x30:
; 0000 007B if (symb == 45){symb=13;}else{
	CPI  R19,45
	BRNE _0x32
	LDI  R19,LOW(13)
	RJMP _0x33
_0x32:
; 0000 007C if (symb == 46){symb=1;}else{
	CPI  R19,46
	BRNE _0x34
	LDI  R19,LOW(1)
	RJMP _0x35
_0x34:
; 0000 007D symb=0;
	LDI  R19,LOW(0)
; 0000 007E }}}}
_0x35:
_0x33:
_0x31:
_0x2F:
; 0000 007F if (symb >13){symb=0;}
	CPI  R19,14
	BRLO _0x36
	LDI  R19,LOW(0)
; 0000 0080 symb=symb*16;
_0x36:
	LDI  R26,LOW(16)
	MULS R19,R26
	MOV  R19,R0
; 0000 0081 for (m=0; m<8; m++){LcdSend(FontKCB[symb]); symb=symb+2;}
	LDI  R16,LOW(0)
_0x38:
	CPI  R16,8
	BRSH _0x39
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	SUBI R16,-1
	RJMP _0x38
_0x39:
; 0000 0082 LcdSend(0x00);
	RCALL SUBOPT_0x1
; 0000 0083 }
	SUBI R17,-1
	RJMP _0x2C
_0x2D:
; 0000 0084 
; 0000 0085 
; 0000 0086 }
	RCALL __LOADLOCR4
	RJMP _0x20A0006
;
;// ::: EN :::::::::::::::::     ::::::::::::::::::::::::::::::::::::::::
;
;
;
;// Timer 0 overflow interrupt service routine
;//    :
;//  0,3        ,      ,     ,  4   5    9
;interrupt [TIM0_OVF] void timer0_ovf_isr(void){
; 0000 008F interrupt [10] void timer0_ovf_isr(void){
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0090 Timer0counter0=Timer0counter0+1;
	INC  R5
; 0000 0091 if (Timer0counter0 >10){
	LDI  R30,LOW(10)
	CP   R30,R5
	BRSH _0x3A
; 0000 0092 Timer0counter0=0;
	CLR  R5
; 0000 0093 FlagShowZamer=1;
	SET
	BLD  R2,0
; 0000 0094 }
; 0000 0095 }
_0x3A:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;
;
;// Declare your global variables here
;
;void main(void){
; 0000 009B void main(void){
_main:
; 0000 009C unsigned int prevV5050, V5050, Vab, Vrx;
; 0000 009D float varSWR, varRX, varRXJ, ftmp0;
; 0000 009E unsigned char varREA, varZNAK, uctmp0, EEprevzamerFLAG_flg;
; 0000 009F bit ZamerOk;
; 0000 00A0 
; 0000 00A1 
; 0000 00A2 
; 0000 00A3 
; 0000 00A4 // Input/Output Ports initialization
; 0000 00A5 // Port B initialization
; 0000 00A6 // Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=In Func0=Out
; 0000 00A7 // State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=T State0=0
; 0000 00A8 PORTB=0x00;
	SBIW R28,22
;	prevV5050 -> R16,R17
;	V5050 -> R18,R19
;	Vab -> R20,R21
;	Vrx -> Y+20
;	varSWR -> Y+16
;	varRX -> Y+12
;	varRXJ -> Y+8
;	ftmp0 -> Y+4
;	varREA -> Y+3
;	varZNAK -> Y+2
;	uctmp0 -> Y+1
;	EEprevzamerFLAG_flg -> Y+0
;	ZamerOk -> R15.0
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 00A9 DDRB=0x2D;
	LDI  R30,LOW(45)
	OUT  0x17,R30
; 0000 00AA 
; 0000 00AB // Port C initialization
; 0000 00AC // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
; 0000 00AD // State6=T State5=T State4=T State3=T State2=T State1=T State0=0
; 0000 00AE PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 00AF DDRC=0x01;
	LDI  R30,LOW(1)
	OUT  0x14,R30
; 0000 00B0 
; 0000 00B1 // Port D initialization
; 0000 00B2 // Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00B3 // State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00B4 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 00B5 DDRD=0x80;
	LDI  R30,LOW(128)
	OUT  0x11,R30
; 0000 00B6 
; 0000 00B7 // Timer/Counter 0 initialization
; 0000 00B8 // Clock source: System Clock
; 0000 00B9 // Clock value: 7,813 kHz
; 0000 00BA TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 00BB TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00BC 
; 0000 00BD // Timer/Counter 1 initialization
; 0000 00BE // Clock source: System Clock
; 0000 00BF // Clock value: Timer1 Stopped
; 0000 00C0 // Mode: Normal top=FFFFh
; 0000 00C1 // OC1A output: Discon.
; 0000 00C2 // OC1B output: Discon.
; 0000 00C3 // Noise Canceler: Off
; 0000 00C4 // Input Capture on Falling Edge
; 0000 00C5 // Timer1 Overflow Interrupt: Off
; 0000 00C6 // Input Capture Interrupt: Off
; 0000 00C7 // Compare A Match Interrupt: Off
; 0000 00C8 // Compare B Match Interrupt: Off
; 0000 00C9 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00CA TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00CB TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00CC TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00CD ICR1H=0x00;
	OUT  0x27,R30
; 0000 00CE ICR1L=0x00;
	OUT  0x26,R30
; 0000 00CF OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00D0 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00D1 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00D2 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00D3 
; 0000 00D4 // Timer/Counter 2 initialization
; 0000 00D5 // Clock source: System Clock
; 0000 00D6 // Clock value: Timer2 Stopped
; 0000 00D7 // Mode: Normal top=FFh
; 0000 00D8 // OC2 output: Disconnected
; 0000 00D9 ASSR=0x00;
	OUT  0x22,R30
; 0000 00DA TCCR2=0x00;
	OUT  0x25,R30
; 0000 00DB TCNT2=0x00;
	OUT  0x24,R30
; 0000 00DC OCR2=0x00;
	OUT  0x23,R30
; 0000 00DD 
; 0000 00DE // External Interrupt(s) initialization
; 0000 00DF // INT0: Off
; 0000 00E0 // INT1: Off
; 0000 00E1 MCUCR=0x00;
	OUT  0x35,R30
; 0000 00E2 
; 0000 00E3 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00E4 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 00E5 
; 0000 00E6 // Analog Comparator initialization
; 0000 00E7 // Analog Comparator: Off
; 0000 00E8 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00E9 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00EA SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00EB 
; 0000 00EC // ADC initialization
; 0000 00ED // ADC Clock frequency: 250,000 kHz
; 0000 00EE // ADC Voltage Reference: Int., cap. on AREF
; 0000 00EF ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(192)
	OUT  0x7,R30
; 0000 00F0 ADCSRA=0x85;
	LDI  R30,LOW(133)
	OUT  0x6,R30
; 0000 00F1 
; 0000 00F2 // SPI initialization
; 0000 00F3 // SPI Type: Master
; 0000 00F4 // SPI Clock Rate: 2000,000 kHz
; 0000 00F5 // SPI Clock Phase: Cycle Half
; 0000 00F6 // SPI Clock Polarity: Low
; 0000 00F7 // SPI Data Order: MSB First
; 0000 00F8 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 00F9 SPSR=0x00;
	LDI  R30,LOW(0)
	OUT  0xE,R30
; 0000 00FA 
; 0000 00FB 
; 0000 00FC // Global enable interrupts
; 0000 00FD #asm("sei")
	sei
; 0000 00FE 
; 0000 00FF //  
; 0000 0100 PORTD.7=0; // reset pin
	CBI  0x12,7
; 0000 0101 delay_us(500);
	RCALL SUBOPT_0x5
; 0000 0102 PORTD.7=1; // reset pin
	SBI  0x12,7
; 0000 0103 delay_us(500);
	RCALL SUBOPT_0x5
; 0000 0104 PORTB.0=0; //    
	CBI  0x18,0
; 0000 0105 LcdSend(0x21);  // LCD Extended Commands.
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x6
; 0000 0106 LcdSend(0xC5);  // Set LCD Vop (Contrast).
	LDI  R30,LOW(197)
	RCALL SUBOPT_0x6
; 0000 0107 LcdSend(0x06);  // Set Temp coefficent.
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x6
; 0000 0108 LcdSend(0x13);  // LCD bias mode 1:48.
	LDI  R30,LOW(19)
	RCALL SUBOPT_0x6
; 0000 0109 LcdSend(0x20);  // LCD Standard Commands, Horizontal addressing mode.
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x6
; 0000 010A LcdSend(0x0C);  // LCD in normal mode.
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x6
; 0000 010B // PORTB.0=1; //    
; 0000 010C ClearLcd();
	RCALL _ClearLcd
; 0000 010D 
; 0000 010E 
; 0000 010F ZamerOk=0;
	CLT
	BLD  R15,0
; 0000 0110 prevV5050=0;
	__GETWRN 16,17,0
; 0000 0111 
; 0000 0112 /*
; 0000 0113 EEprevzamerFLAG_flg=EEprevzamerFLAG;
; 0000 0114 if (EEprevzamerFLAG_flg >0){
; 0000 0115 for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer1[uctmp0];}
; 0000 0116 StringToLcd(1);
; 0000 0117 for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer0[uctmp0];}
; 0000 0118 }else{
; 0000 0119 for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer0[uctmp0];}
; 0000 011A StringToLcd(1);
; 0000 011B for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer1[uctmp0];}
; 0000 011C }
; 0000 011D StringToLcd(2);
; 0000 011E */
; 0000 011F 
; 0000 0120 
; 0000 0121 PORTC.0=0; //  1:3.03
	CBI  0x15,0
; 0000 0122 while (1){
_0x43:
; 0000 0123 
; 0000 0124 V5050=read_adc(3);
	RCALL SUBOPT_0x7
; 0000 0125 if (V5050 > 1020){
	__CPWRN 18,19,1021
	BRLO _0x46
; 0000 0126 PORTC.0=1; //  1:13.03
	SBI  0x15,0
; 0000 0127 V5050=read_adc(3);
	RCALL SUBOPT_0x7
; 0000 0128 }
; 0000 0129 Vrx=read_adc(1);
_0x46:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _read_adc
	STD  Y+20,R30
	STD  Y+20+1,R31
; 0000 012A Vab=read_adc(2);
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R20,R30
; 0000 012B 
; 0000 012C if (V5050 >10){
	__CPWRN 18,19,11
	BRSH PC+2
	RJMP _0x49
; 0000 012D if (V5050 > (prevV5050+10)){prevV5050=V5050;}else{
	MOVW R30,R16
	ADIW R30,10
	CP   R30,R18
	CPC  R31,R19
	BRSH _0x4A
	MOVW R16,R18
	RJMP _0x4B
_0x4A:
; 0000 012E 
; 0000 012F if (Vab < V5050){
	__CPWRR 20,21,18,19
	BRLO PC+2
	RJMP _0x4C
; 0000 0130 ftmp0 = (float)((float)Vab/(float)((float)V5050*2)); // = V/Vs
	MOVW R30,R20
	RCALL SUBOPT_0x8
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x9
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	RCALL SUBOPT_0xA
; 0000 0131 varRX = (((50*ftmp0)+25) / (0.5 - ftmp0));
	RCALL SUBOPT_0xB
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xC
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	RCALL SUBOPT_0xD
; 0000 0132 varSWR = varRX/50;
	RCALL SUBOPT_0xE
	__GETD1N 0x42480000
	RCALL __DIVF21
	RCALL SUBOPT_0xF
; 0000 0133 if (varSWR > 9.99){varSWR=9.99;}
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x4D
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xF
; 0000 0134 if (V5050 != Vrx){if (V5050 > Vrx){varZNAK='-';}else{varZNAK='+';}}else{varZNAK=' ';}
_0x4D:
	RCALL SUBOPT_0x12
	BREQ _0x4E
	RCALL SUBOPT_0x12
	BRSH _0x4F
	LDI  R30,LOW(45)
	RJMP _0x5D
_0x4F:
	LDI  R30,LOW(43)
_0x5D:
	STD  Y+2,R30
	RJMP _0x51
_0x4E:
	LDI  R30,LOW(32)
	STD  Y+2,R30
_0x51:
; 0000 0135 
; 0000 0136 if (Vrx > V5050){
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	CP   R18,R26
	CPC  R19,R27
	BRSH _0x52
; 0000 0137 ftmp0 = (float)((float)(Vrx-V5050)/(float)((float)V5050*2)); // = V/Vs
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	SUB  R30,R18
	SBC  R31,R19
	RCALL SUBOPT_0x8
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x9
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RJMP _0x5E
; 0000 0138 }else{
_0x52:
; 0000 0139 ftmp0 = (float)((float)(V5050-Vrx)/(float)((float)V5050*2)); // = V/Vs
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	MOVW R30,R18
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x8
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x9
	POP  R26
	POP  R27
	POP  R24
	POP  R25
_0x5E:
	RCALL __DIVF21
	RCALL SUBOPT_0xA
; 0000 013A }
; 0000 013B varRXJ = (((50*ftmp0)+25) / (0.5 - ftmp0));
	RCALL SUBOPT_0xB
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xC
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	__PUTD1S 8
; 0000 013C if (varRXJ > varRX){ftmp0=varRX/varRXJ;}else{ftmp0=varRXJ/varRX;}
	RCALL SUBOPT_0x13
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x54
	__GETD1S 8
	RCALL SUBOPT_0xE
	RJMP _0x5F
_0x54:
	RCALL SUBOPT_0x13
_0x5F:
	RCALL __DIVF21
	RCALL SUBOPT_0xA
; 0000 013D varREA=(unsigned char)(99*(1-ftmp0));
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	RCALL __SUBF12
	__GETD2N 0x42C60000
	RCALL __MULF12
	RCALL __CFD1U
	RJMP _0x60
; 0000 013E 
; 0000 013F }else{
_0x4C:
; 0000 0140 varSWR=0.00;
	LDI  R30,LOW(0)
	__CLRD1S 16
; 0000 0141 varZNAK=' ';
	LDI  R30,LOW(32)
	STD  Y+2,R30
; 0000 0142 varREA=0;
	LDI  R30,LOW(0)
_0x60:
	STD  Y+3,R30
; 0000 0143 }
; 0000 0144 for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=0;}
	LDI  R30,LOW(0)
	STD  Y+1,R30
_0x58:
	LDD  R26,Y+1
	CPI  R26,LOW(0x8)
	BRSH _0x59
	LDD  R30,Y+1
	RCALL SUBOPT_0x16
	SUBI R30,LOW(-_stringBuff)
	SBCI R31,HIGH(-_stringBuff)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	LDD  R30,Y+1
	SUBI R30,-LOW(1)
	STD  Y+1,R30
	RJMP _0x58
_0x59:
; 0000 0145 sprintf(stringBuff, "%1.2f%c %u", varSWR, varZNAK, varREA);
	LDI  R30,LOW(_stringBuff)
	LDI  R31,HIGH(_stringBuff)
	RCALL SUBOPT_0x17
	__POINTW1FN _0x0,0
	RCALL SUBOPT_0x17
	__GETD1S 20
	RCALL __PUTPARD1
	LDD  R30,Y+10
	RCALL SUBOPT_0x18
	LDD  R30,Y+15
	RCALL SUBOPT_0x18
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
; 0000 0146 StringToLcd(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _StringToLcd
; 0000 0147 FlagShowZamer=1;
	SET
	BLD  R2,0
; 0000 0148 if (!ZamerOk){ZamerOk=1; Timer0counter0=250;}
	SBRC R15,0
	RJMP _0x5A
	BLD  R15,0
	LDI  R30,LOW(250)
	MOV  R5,R30
; 0000 0149 } // if (V5050 > prevV5050)
_0x5A:
_0x4B:
; 0000 014A }else{
	RJMP _0x5B
_0x49:
; 0000 014B prevV5050=0;
	__GETWRN 16,17,0
; 0000 014C }
_0x5B:
; 0000 014D 
; 0000 014E 
; 0000 014F 
; 0000 0150 
; 0000 0151 
; 0000 0152 /*
; 0000 0153 if (ZamerOk){
; 0000 0154 // save eeprom
; 0000 0155 if (EEprevzamerFLAG_flg >0){
; 0000 0156 for (uctmp0=0; uctmp0 <8; uctmp0++){EEprevzamer1[uctmp0]=stringBuff[uctmp0];}
; 0000 0157 EEprevzamerFLAG=0;
; 0000 0158 EEprevzamerFLAG_flg=0;
; 0000 0159 }else{
; 0000 015A for (uctmp0=0; uctmp0 <8; uctmp0++){EEprevzamer0[uctmp0]=stringBuff[uctmp0];}
; 0000 015B EEprevzamerFLAG=1;
; 0000 015C EEprevzamerFLAG_flg=1;
; 0000 015D }
; 0000 015E }
; 0000 015F */
; 0000 0160 
; 0000 0161 
; 0000 0162 
; 0000 0163 };
	RJMP _0x43
; 0000 0164 }
_0x5C:
	RJMP _0x5C
;
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x19
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	RCALL SUBOPT_0x19
	ADIW R26,2
	RCALL SUBOPT_0x1B
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0x19
	RCALL __GETW1P
	TST  R31
	BRMI _0x2000014
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1B
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	RCALL SUBOPT_0x19
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	RCALL __LOADLOCR2
_0x20A0006:
	ADIW R28,5
	RET
__ftoe_G100:
	RCALL SUBOPT_0x1C
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x1D
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x2000019
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RCALL SUBOPT_0x17
	__POINTW1FN _0x2000000,0
	RCALL SUBOPT_0x1E
	RJMP _0x20A0005
_0x2000019:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x2000018
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x17
	__POINTW1FN _0x2000000,1
	RCALL SUBOPT_0x1E
	RJMP _0x20A0005
_0x2000018:
	LDD  R26,Y+11
	CPI  R26,LOW(0x7)
	BRLO _0x200001B
	LDI  R30,LOW(6)
	STD  Y+11,R30
_0x200001B:
	LDD  R17,Y+11
_0x200001C:
	RCALL SUBOPT_0x20
	BREQ _0x200001E
	RCALL SUBOPT_0x21
	RJMP _0x200001C
_0x200001E:
	RCALL SUBOPT_0x22
	RCALL __CPD10
	BRNE _0x200001F
	LDI  R19,LOW(0)
	RCALL SUBOPT_0x21
	RJMP _0x2000020
_0x200001F:
	LDD  R19,Y+11
	RCALL SUBOPT_0x23
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2000021
	RCALL SUBOPT_0x21
_0x2000022:
	RCALL SUBOPT_0x23
	BRLO _0x2000024
	RCALL SUBOPT_0x24
	RJMP _0x2000022
_0x2000024:
	RJMP _0x2000025
_0x2000021:
_0x2000026:
	RCALL SUBOPT_0x23
	BRSH _0x2000028
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0xD
	SUBI R19,LOW(1)
	RJMP _0x2000026
_0x2000028:
	RCALL SUBOPT_0x21
_0x2000025:
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x23
	BRLO _0x2000029
	RCALL SUBOPT_0x24
_0x2000029:
_0x2000020:
	LDI  R17,LOW(0)
_0x200002A:
	LDD  R30,Y+11
	CP   R30,R17
	BRLO _0x200002C
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x26
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0xA
	__GETD1S 4
	RCALL SUBOPT_0xE
	RCALL __DIVF21
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x29
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL SUBOPT_0x14
	RCALL __MULF12
	RCALL SUBOPT_0xE
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0xD
	MOV  R30,R17
	SUBI R17,-1
	CPI  R30,0
	BRNE _0x200002A
	RCALL SUBOPT_0x28
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x200002A
_0x200002C:
	RCALL SUBOPT_0x2A
	LDD  R26,Y+10
	STD  Z+0,R26
	CPI  R19,0
	BRGE _0x200002E
	RCALL SUBOPT_0x28
	LDI  R30,LOW(45)
	ST   X,R30
	NEG  R19
_0x200002E:
	CPI  R19,10
	BRLT _0x200002F
	RCALL SUBOPT_0x2A
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	RCALL __DIVB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
_0x200002F:
	RCALL SUBOPT_0x2A
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	RCALL __MODB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20A0005:
	RCALL __LOADLOCR4
	ADIW R28,16
	RET
__print_G100:
	SBIW R28,63
	SBIW R28,17
	RCALL __SAVELOCR6
	LDI  R17,0
	__GETW1SX 88
	STD  Y+8,R30
	STD  Y+8+1,R31
	__GETW1SX 86
	STD  Y+6,R30
	STD  Y+6+1,R31
	RCALL SUBOPT_0x2B
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000030:
	MOVW R26,R28
	SUBI R26,LOW(-(92))
	SBCI R27,HIGH(-(92))
	RCALL SUBOPT_0x1B
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000032
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2000036
	CPI  R18,37
	BRNE _0x2000037
	LDI  R17,LOW(1)
	RJMP _0x2000038
_0x2000037:
	RCALL SUBOPT_0x2C
_0x2000038:
	RJMP _0x2000035
_0x2000036:
	CPI  R30,LOW(0x1)
	BRNE _0x2000039
	CPI  R18,37
	BRNE _0x200003A
	RCALL SUBOPT_0x2C
	RJMP _0x200010E
_0x200003A:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+21,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x200003B
	LDI  R16,LOW(1)
	RJMP _0x2000035
_0x200003B:
	CPI  R18,43
	BRNE _0x200003C
	LDI  R30,LOW(43)
	STD  Y+21,R30
	RJMP _0x2000035
_0x200003C:
	CPI  R18,32
	BRNE _0x200003D
	LDI  R30,LOW(32)
	STD  Y+21,R30
	RJMP _0x2000035
_0x200003D:
	RJMP _0x200003E
_0x2000039:
	CPI  R30,LOW(0x2)
	BRNE _0x200003F
_0x200003E:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000040
	ORI  R16,LOW(128)
	RJMP _0x2000035
_0x2000040:
	RJMP _0x2000041
_0x200003F:
	CPI  R30,LOW(0x3)
	BRNE _0x2000042
_0x2000041:
	CPI  R18,48
	BRLO _0x2000044
	CPI  R18,58
	BRLO _0x2000045
_0x2000044:
	RJMP _0x2000043
_0x2000045:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x2000035
_0x2000043:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0x2000046
	LDI  R17,LOW(4)
	RJMP _0x2000035
_0x2000046:
	RJMP _0x2000047
_0x2000042:
	CPI  R30,LOW(0x4)
	BRNE _0x2000049
	CPI  R18,48
	BRLO _0x200004B
	CPI  R18,58
	BRLO _0x200004C
_0x200004B:
	RJMP _0x200004A
_0x200004C:
	ORI  R16,LOW(32)
	LDI  R26,LOW(10)
	MUL  R20,R26
	MOV  R20,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x2000035
_0x200004A:
_0x2000047:
	CPI  R18,108
	BRNE _0x200004D
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x2000035
_0x200004D:
	RJMP _0x200004E
_0x2000049:
	CPI  R30,LOW(0x5)
	BREQ PC+2
	RJMP _0x2000035
_0x200004E:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2000053
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x2D
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x2F
	RJMP _0x2000054
_0x2000053:
	CPI  R30,LOW(0x45)
	BREQ _0x2000057
	CPI  R30,LOW(0x65)
	BRNE _0x2000058
_0x2000057:
	RJMP _0x2000059
_0x2000058:
	CPI  R30,LOW(0x66)
	BRNE _0x200005A
_0x2000059:
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x31
	RCALL __GETD1P
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x33
	LDD  R26,Y+13
	TST  R26
	BRMI _0x200005B
	LDD  R26,Y+21
	CPI  R26,LOW(0x2B)
	BREQ _0x200005D
	RJMP _0x200005E
_0x200005B:
	RCALL SUBOPT_0x34
	RCALL __ANEGF1
	RCALL SUBOPT_0x32
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x200005D:
	SBRS R16,7
	RJMP _0x200005F
	LDD  R30,Y+21
	ST   -Y,R30
	RCALL SUBOPT_0x2F
	RJMP _0x2000060
_0x200005F:
	RCALL SUBOPT_0x1D
	ADIW R30,1
	RCALL SUBOPT_0x35
	SBIW R30,1
	LDD  R26,Y+21
	STD  Z+0,R26
_0x2000060:
_0x200005E:
	SBRS R16,5
	LDI  R20,LOW(6)
	CPI  R18,102
	BRNE _0x2000062
	RCALL SUBOPT_0x34
	RCALL __PUTPARD1
	ST   -Y,R20
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	RCALL SUBOPT_0x17
	RCALL _ftoa
	RJMP _0x2000063
_0x2000062:
	RCALL SUBOPT_0x34
	RCALL __PUTPARD1
	ST   -Y,R20
	ST   -Y,R18
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	RCALL SUBOPT_0x17
	RCALL __ftoe_G100
_0x2000063:
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x36
	RJMP _0x2000064
_0x200005A:
	CPI  R30,LOW(0x73)
	BRNE _0x2000066
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x36
	RJMP _0x2000067
_0x2000066:
	CPI  R30,LOW(0x70)
	BRNE _0x2000069
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x17
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000067:
	ANDI R16,LOW(127)
	CPI  R20,0
	BREQ _0x200006B
	CP   R20,R17
	BRLO _0x200006C
_0x200006B:
	RJMP _0x200006A
_0x200006C:
	MOV  R17,R20
_0x200006A:
_0x2000064:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+20,R30
	LDI  R19,LOW(0)
	RJMP _0x200006D
_0x2000069:
	CPI  R30,LOW(0x64)
	BREQ _0x2000070
	CPI  R30,LOW(0x69)
	BRNE _0x2000071
_0x2000070:
	ORI  R16,LOW(4)
	RJMP _0x2000072
_0x2000071:
	CPI  R30,LOW(0x75)
	BRNE _0x2000073
_0x2000072:
	LDI  R30,LOW(10)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x2000074
	__GETD1N 0x3B9ACA00
	RCALL SUBOPT_0xF
	LDI  R17,LOW(10)
	RJMP _0x2000075
_0x2000074:
	__GETD1N 0x2710
	RCALL SUBOPT_0xF
	LDI  R17,LOW(5)
	RJMP _0x2000075
_0x2000073:
	CPI  R30,LOW(0x58)
	BRNE _0x2000077
	ORI  R16,LOW(8)
	RJMP _0x2000078
_0x2000077:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x20000B6
_0x2000078:
	LDI  R30,LOW(16)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x200007A
	__GETD1N 0x10000000
	RCALL SUBOPT_0xF
	LDI  R17,LOW(8)
	RJMP _0x2000075
_0x200007A:
	__GETD1N 0x1000
	RCALL SUBOPT_0xF
	LDI  R17,LOW(4)
_0x2000075:
	CPI  R20,0
	BREQ _0x200007B
	ANDI R16,LOW(127)
	RJMP _0x200007C
_0x200007B:
	LDI  R20,LOW(1)
_0x200007C:
	SBRS R16,1
	RJMP _0x200007D
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x31
	ADIW R26,4
	RCALL __GETD1P
	RJMP _0x200010F
_0x200007D:
	SBRS R16,2
	RJMP _0x200007F
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x37
	RCALL __CWD1
	RJMP _0x200010F
_0x200007F:
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x37
	CLR  R22
	CLR  R23
_0x200010F:
	__PUTD1S 10
	SBRS R16,2
	RJMP _0x2000081
	LDD  R26,Y+13
	TST  R26
	BRPL _0x2000082
	RCALL SUBOPT_0x34
	RCALL __ANEGD1
	RCALL SUBOPT_0x32
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x2000082:
	LDD  R30,Y+21
	CPI  R30,0
	BREQ _0x2000083
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0x2000084
_0x2000083:
	ANDI R16,LOW(251)
_0x2000084:
_0x2000081:
	MOV  R19,R20
_0x200006D:
	SBRC R16,0
	RJMP _0x2000085
_0x2000086:
	CP   R17,R21
	BRSH _0x2000089
	CP   R19,R21
	BRLO _0x200008A
_0x2000089:
	RJMP _0x2000088
_0x200008A:
	SBRS R16,7
	RJMP _0x200008B
	SBRS R16,2
	RJMP _0x200008C
	ANDI R16,LOW(251)
	LDD  R18,Y+21
	SUBI R17,LOW(1)
	RJMP _0x200008D
_0x200008C:
	LDI  R18,LOW(48)
_0x200008D:
	RJMP _0x200008E
_0x200008B:
	LDI  R18,LOW(32)
_0x200008E:
	RCALL SUBOPT_0x2C
	SUBI R21,LOW(1)
	RJMP _0x2000086
_0x2000088:
_0x2000085:
_0x200008F:
	CP   R17,R20
	BRSH _0x2000091
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2000092
	RCALL SUBOPT_0x38
	BREQ _0x2000093
	SUBI R21,LOW(1)
_0x2000093:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0x2000092:
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL SUBOPT_0x2F
	CPI  R21,0
	BREQ _0x2000094
	SUBI R21,LOW(1)
_0x2000094:
	SUBI R20,LOW(1)
	RJMP _0x200008F
_0x2000091:
	MOV  R19,R17
	LDD  R30,Y+20
	CPI  R30,0
	BRNE _0x2000095
_0x2000096:
	CPI  R19,0
	BREQ _0x2000098
	SBRS R16,3
	RJMP _0x2000099
	RCALL SUBOPT_0x1D
	LPM  R18,Z+
	RCALL SUBOPT_0x35
	RJMP _0x200009A
_0x2000099:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LD   R18,X+
	STD  Y+14,R26
	STD  Y+14+1,R27
_0x200009A:
	RCALL SUBOPT_0x2C
	CPI  R21,0
	BREQ _0x200009B
	SUBI R21,LOW(1)
_0x200009B:
	SUBI R19,LOW(1)
	RJMP _0x2000096
_0x2000098:
	RJMP _0x200009C
_0x2000095:
_0x200009E:
	RCALL SUBOPT_0x39
	RCALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x20000A0
	SBRS R16,3
	RJMP _0x20000A1
	SUBI R18,-LOW(55)
	RJMP _0x20000A2
_0x20000A1:
	SUBI R18,-LOW(87)
_0x20000A2:
	RJMP _0x20000A3
_0x20000A0:
	SUBI R18,-LOW(48)
_0x20000A3:
	SBRC R16,4
	RJMP _0x20000A5
	CPI  R18,49
	BRSH _0x20000A7
	RCALL SUBOPT_0x10
	__CPD2N 0x1
	BRNE _0x20000A6
_0x20000A7:
	RJMP _0x20000A9
_0x20000A6:
	CP   R20,R19
	BRSH _0x2000110
	CP   R21,R19
	BRLO _0x20000AC
	SBRS R16,0
	RJMP _0x20000AD
_0x20000AC:
	RJMP _0x20000AB
_0x20000AD:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x20000AE
_0x2000110:
	LDI  R18,LOW(48)
_0x20000A9:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x20000AF
	RCALL SUBOPT_0x38
	BREQ _0x20000B0
	SUBI R21,LOW(1)
_0x20000B0:
_0x20000AF:
_0x20000AE:
_0x20000A5:
	RCALL SUBOPT_0x2C
	CPI  R21,0
	BREQ _0x20000B1
	SUBI R21,LOW(1)
_0x20000B1:
_0x20000AB:
	SUBI R19,LOW(1)
	RCALL SUBOPT_0x39
	RCALL __MODD21U
	RCALL SUBOPT_0x32
	LDD  R30,Y+20
	RCALL SUBOPT_0x10
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __DIVD21U
	RCALL SUBOPT_0xF
	__GETD1S 16
	RCALL __CPD10
	BREQ _0x200009F
	RJMP _0x200009E
_0x200009F:
_0x200009C:
	SBRS R16,0
	RJMP _0x20000B2
_0x20000B3:
	CPI  R21,0
	BREQ _0x20000B5
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x2F
	RJMP _0x20000B3
_0x20000B5:
_0x20000B2:
_0x20000B6:
_0x2000054:
_0x200010E:
	LDI  R17,LOW(0)
_0x2000035:
	RJMP _0x2000030
_0x2000032:
	RCALL SUBOPT_0x2B
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,31
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x3A
	SBIW R30,0
	BRNE _0x20000B7
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20A0004
_0x20000B7:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x3A
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x17
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	RCALL SUBOPT_0x17
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0x17
	RCALL __print_G100
	MOVW R18,R30
	RCALL SUBOPT_0x2B
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20A0004:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	RCALL SUBOPT_0x3B
	RCALL __PUTPARD1
	RCALL _ftrunc
	RCALL __PUTD1S0
    brne __floor1
__floor0:
	RCALL SUBOPT_0x3B
	RJMP _0x20A0003
__floor1:
    brtc __floor0
	RCALL SUBOPT_0x3B
	__GETD2N 0x3F800000
	RCALL __SUBF12
_0x20A0003:
	ADIW R28,4
	RET

	.CSEG
_ftoa:
	RCALL SUBOPT_0x1C
	LDI  R30,LOW(0)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	RCALL __SAVELOCR2
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x208000D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL SUBOPT_0x17
	__POINTW1FN _0x2080000,0
	RCALL SUBOPT_0x1E
	RJMP _0x20A0002
_0x208000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x208000C
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL SUBOPT_0x17
	__POINTW1FN _0x2080000,1
	RCALL SUBOPT_0x1E
	RJMP _0x20A0002
_0x208000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x208000F
	RCALL SUBOPT_0x3C
	RCALL __ANEGF1
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x3E
	LDI  R30,LOW(45)
	ST   X,R30
_0x208000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2080010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2080010:
	LDD  R17,Y+8
_0x2080011:
	RCALL SUBOPT_0x20
	BREQ _0x2080013
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x40
	RJMP _0x2080011
_0x2080013:
	RCALL SUBOPT_0x41
	RCALL __ADDF12
	RCALL SUBOPT_0x3D
	LDI  R17,LOW(0)
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x40
_0x2080014:
	RCALL SUBOPT_0x41
	RCALL __CMPF12
	BRLO _0x2080016
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x40
	SUBI R17,-LOW(1)
	RJMP _0x2080014
_0x2080016:
	CPI  R17,0
	BRNE _0x2080017
	RCALL SUBOPT_0x3E
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2080018
_0x2080017:
_0x2080019:
	RCALL SUBOPT_0x20
	BREQ _0x208001B
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x26
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	RCALL __DIVF21
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x3F
	RCALL __CWD1
	RCALL __CDF1
	RCALL __MULF12
	RCALL SUBOPT_0x42
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x3D
	RJMP _0x2080019
_0x208001B:
_0x2080018:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x20A0001
	RCALL SUBOPT_0x3E
	LDI  R30,LOW(46)
	ST   X,R30
_0x208001D:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x208001F
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x3C
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x42
	RCALL __CWD1
	RCALL __CDF1
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x3D
	RJMP _0x208001D
_0x208001F:
_0x20A0001:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20A0002:
	RCALL __LOADLOCR2
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.DSEG
_FontKCB:
	.BYTE 0xE0
_stringBuff:
	.BYTE 0x9
__seed_G104:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x0:
	ORI  R30,0x40
	ST   -Y,R30
	RCALL _LcdSend
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _LcdSend
	SBI  0x18,0
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _LcdSend

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2:
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_stringBuff)
	SBCI R31,HIGH(-_stringBuff)
	LD   R19,Z
	CPI  R19,48
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3:
	MOV  R30,R19
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	SUBI R30,LOW(-_FontKCB)
	SBCI R31,HIGH(-_FontKCB)
	LD   R30,Z
	ST   -Y,R30
	RCALL _LcdSend
	SUBI R19,-LOW(2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	__DELAY_USW 1000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	RJMP _LcdSend

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x8:
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x9:
	MOVW R30,R18
	RCALL SUBOPT_0x8
	__GETD2N 0x40000000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xA:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xB:
	__GETD1S 4
	__GETD2N 0x42480000
	RCALL __MULF12
	__GETD2N 0x41C80000
	RCALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	__GETD2S 4
	__GETD1N 0x3F000000
	RCALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xD:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0xE:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xF:
	__PUTD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x10:
	__GETD2S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	__GETD1N 0x411FD70A
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	CP   R30,R18
	CPC  R31,R19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	__GETD1S 12
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x14:
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	__GETD1N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 29 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x17:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1B:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1D:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	RCALL SUBOPT_0x17
	RJMP _strcpyf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x20:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x21:
	RCALL SUBOPT_0x14
	__GETD1N 0x41200000
	RCALL __MULF12
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	__GETD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x23:
	__GETD1S 4
	RCALL SUBOPT_0xE
	RCALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x24:
	RCALL SUBOPT_0xE
	__GETD1N 0x3DCCCCCD
	RCALL __MULF12
	RCALL SUBOPT_0xD
	SUBI R19,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x25:
	__GETD1N 0x41200000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x26:
	__GETD2N 0x3F000000
	RCALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x27:
	__GETD1N 0x3DCCCCCD
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x28:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x29:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2A:
	RCALL SUBOPT_0x1F
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x2C:
	ST   -Y,R18
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	RCALL SUBOPT_0x17
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x2D:
	__GETW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x2E:
	SBIW R30,4
	__PUTW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2F:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	RCALL SUBOPT_0x17
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	MOVW R30,R28
	ADIW R30,22
	STD  Y+14,R30
	STD  Y+14+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x31:
	__GETW2SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x32:
	__PUTD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	RCALL SUBOPT_0x2D
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x34:
	__GETD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x35:
	STD  Y+14,R30
	STD  Y+14+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x17
	RCALL _strlen
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	RCALL SUBOPT_0x31
	RJMP SUBOPT_0x1A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x38:
	ANDI R16,LOW(251)
	LDD  R30,Y+21
	ST   -Y,R30
	__GETW1SX 87
	RCALL SUBOPT_0x17
	__GETW1SX 91
	ICALL
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x39:
	__GETD1S 16
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3A:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3B:
	RCALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3C:
	__GETD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x3D:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x3E:
	RCALL SUBOPT_0x2B
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3F:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x40:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x41:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x42:
	__GETD2S 9
	RET


	.CSEG
__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
