/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Date    : 17.11.2012


Chip type               : ATmega8L
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <stdio.h>


#include "font_8x14.c"

#define ADC_VREF_TYPE 0xC0


__eeprom unsigned char EEprevzamerFLAG;    //  
__eeprom unsigned char EEprevzamer0[8];    //  
__eeprom unsigned char EEprevzamer1[8];    //  

unsigned char stringBuff[9];
unsigned char Timer0counter0=0;
bit FlagShowZamer=0;



// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input){
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}




// ::: ST :::::::::::::::::    ::::::::::::::::::::::::::::::::::::::::

void LcdSend(unsigned char data){
//  Send data to display controller.
SPDR = data;
//  Wait until Tx register empty.
while ( (SPSR & 0x80) != 0x80 );
return;
}

// ::: EN :::::::::::::::::    ::::::::::::::::::::::::::::::::::::::::



// ::: ST :::::::::::::::::   ::::::::::::::::::::::::::::::::::::::::
void ClearLcd(void){
unsigned char col, page;

for(page = 0; page < 8; page++){
PORTB.0=0; //    
LcdSend((page | 0x40));
LcdSend(0x80);
PORTB.0=1; //    
for (col = 0; col < 96; col++){LcdSend(0x00);}

}

}
// ::: EN :::::::::::::::::   ::::::::::::::::::::::::::::::::::::::::



// ::: ST :::::::::::::::::     ::::::::::::::::::::::::::::::::::::::::
void StringToLcd(unsigned char stringnum){
unsigned char n, m, symb;
PORTB.0=0; //    
LcdSend((stringnum*2) | 0x40);
LcdSend(0x80);
PORTB.0=1; //    

for (n=0; n<8; n++){
symb=stringBuff[n];
if (symb >47){symb=symb-46;}else{
if (symb == 43){symb=12;}else{
if (symb == 45){symb=13;}else{
if (symb == 46){symb=1;}else{
symb=0;
}}}}
if (symb >13){symb=0;}
symb=symb*16+1;
for (m=0; m<8; m++){LcdSend(FontKCB[symb]); symb=symb+2;}
LcdSend(0x00);
}

PORTB.0=0; //    
LcdSend((stringnum*2+1) | 0x40);
LcdSend(0x80);
PORTB.0=1; //    

for (n=0; n<8; n++){
symb=stringBuff[n];
if (symb >47){symb=symb-46;}else{
if (symb == 43){symb=12;}else{
if (symb == 45){symb=13;}else{
if (symb == 46){symb=1;}else{
symb=0;
}}}}
if (symb >13){symb=0;}
symb=symb*16;
for (m=0; m<8; m++){LcdSend(FontKCB[symb]); symb=symb+2;}
LcdSend(0x00);
}


}

// ::: EN :::::::::::::::::     ::::::::::::::::::::::::::::::::::::::::



// Timer 0 overflow interrupt service routine
//    :
//  0,3        ,      ,     ,  4   5    9
interrupt [TIM0_OVF] void timer0_ovf_isr(void){
Timer0counter0=Timer0counter0+1;
if (Timer0counter0 >10){
Timer0counter0=0;
FlagShowZamer=1;
}
}



// Declare your global variables here

void main(void){
unsigned int prevV5050, V5050, Vab, Vrx;
float varSWR, varRX, varRXJ, ftmp0;
unsigned char varREA, varZNAK, uctmp0, EEprevzamerFLAG_flg;
bit ZamerOk;




// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=In Func0=Out
// State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=T State0=0
PORTB=0x00;
DDRB=0x2D;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
// State6=T State5=T State4=T State3=T State2=T State1=T State0=0
PORTC=0x00;
DDRC=0x01;

// Port D initialization
// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTD=0x00;
DDRD=0x80;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
TCCR0=0x05;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 250,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x85;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x00;


// Global enable interrupts
#asm("sei")

//  
PORTD.7=0; // reset pin
delay_us(500);
PORTD.7=1; // reset pin
delay_us(500);
PORTB.0=0; //    
LcdSend(0x21);  // LCD Extended Commands.
LcdSend(0xC5);  // Set LCD Vop (Contrast).
LcdSend(0x06);  // Set Temp coefficent.
LcdSend(0x13);  // LCD bias mode 1:48.
LcdSend(0x20);  // LCD Standard Commands, Horizontal addressing mode.
LcdSend(0x0C);  // LCD in normal mode.
// PORTB.0=1; //    
ClearLcd();


ZamerOk=0;
prevV5050=0;

/*
EEprevzamerFLAG_flg=EEprevzamerFLAG;
if (EEprevzamerFLAG_flg >0){
for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer1[uctmp0];}
StringToLcd(1);
for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer0[uctmp0];}
}else{
for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer0[uctmp0];}
StringToLcd(1);
for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=EEprevzamer1[uctmp0];}
}
StringToLcd(2);
*/


PORTC.0=0; //  1:3.03
while (1){

V5050=read_adc(3);
if (V5050 > 1020){
PORTC.0=1; //  1:13.03
V5050=read_adc(3);
}
Vrx=read_adc(1);
Vab=read_adc(2);

if (V5050 >10){
if (V5050 > (prevV5050+10)){prevV5050=V5050;}else{

if (Vab < V5050){
ftmp0 = (float)((float)Vab/(float)((float)V5050*2)); // = V/Vs
varRX = (((50*ftmp0)+25) / (0.5 - ftmp0));
varSWR = varRX/50;
if (varSWR > 9.99){varSWR=9.99;}
if (V5050 != Vrx){if (V5050 > Vrx){varZNAK='-';}else{varZNAK='+';}}else{varZNAK=' ';}

if (Vrx > V5050){
ftmp0 = (float)((float)(Vrx-V5050)/(float)((float)V5050*2)); // = V/Vs
}else{
ftmp0 = (float)((float)(V5050-Vrx)/(float)((float)V5050*2)); // = V/Vs
}
varRXJ = (((50*ftmp0)+25) / (0.5 - ftmp0));
if (varRXJ > varRX){ftmp0=varRX/varRXJ;}else{ftmp0=varRXJ/varRX;}
varREA=(unsigned char)(99*(1-ftmp0));

}else{
varSWR=0.00;
varZNAK=' ';
varREA=0;
}
for (uctmp0=0; uctmp0 <8; uctmp0++){stringBuff[uctmp0]=0;}
sprintf(stringBuff, "%1.2f%c %u", varSWR, varZNAK, varREA);
StringToLcd(0);
FlagShowZamer=1;
if (!ZamerOk){ZamerOk=1; Timer0counter0=250;}
} // if (V5050 > prevV5050)
}else{
prevV5050=0;
}





/*
if (ZamerOk){
// save eeprom
if (EEprevzamerFLAG_flg >0){
for (uctmp0=0; uctmp0 <8; uctmp0++){EEprevzamer1[uctmp0]=stringBuff[uctmp0];}
EEprevzamerFLAG=0;
EEprevzamerFLAG_flg=0;
}else{
for (uctmp0=0; uctmp0 <8; uctmp0++){EEprevzamer0[uctmp0]=stringBuff[uctmp0];}
EEprevzamerFLAG=1;
EEprevzamerFLAG_flg=1;
}
}
*/



};
}


